#version 330

in vec3 position;
in vec3 normal;

// Task 1: add output variable of type vec3 for vNormal
// Task 4: add output variable of type vec3 for vPosition

uniform mat4 MVP; // model-view-projection matrix
uniform mat3 N; // transpose of inversed model matrix
uniform mat4 model; // model matrix

void main() {
    // Task 1: calculate vNormal by multiplying transpose of inversed model matrix by vertex normals
    //           the result has to be normalized

    // Task 4: calculate vertex world position by multiplying only *model* matrix by vertex position
    //         hint: you can only multiply matrix by a vector of the same size (mat4 * vec4), use 1.0 for 4th (w) coordinate (like you see below in gl_Position)
    //           retrieve only first 3 components and store them to vPosition variable

    gl_Position = MVP * vec4(position, 1.0);
}